diff --git a/elf/Makefile b/elf/Makefile
index e852b5f..34450ea 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -121,7 +121,7 @@ tests = tst-tls1 tst-tls2 tst-tls9 tst-leaks1 \
 	tst-auxv
 tests-static = tst-tls1-static tst-tls2-static tst-stackguard1-static \
 	       tst-leaks1-static tst-array1-static tst-array5-static \
-	       tst-ptrguard1-static tst-dl-iter-static
+	       tst-ptrguard1-static tst-dl-iter-static tst-tlsalign-static
 ifeq (yes,$(build-shared))
 tests-static += tst-tls9-static
 tst-tls9-static-ENV = \
@@ -146,7 +146,7 @@ tests += loadtest restest1 preloadtest loadfail multiload origtest resolvfail \
 	 tst-stackguard1 tst-addr1 tst-thrlock \
 	 tst-unique1 tst-unique2 $(if $(CXX),tst-unique3 tst-unique4) \
 	 tst-initorder tst-initorder2 tst-relsort1 tst-null-argv \
-	 tst-ptrguard1
+	 tst-ptrguard1 tst-tlsalign
 #	 reldep9
 ifeq ($(build-hardcoded-path-in-tests),yes)
 tests += tst-dlopen-aout
@@ -212,7 +212,8 @@ modules-names = testobj1 testobj2 testobj3 testobj4 testobj5 testobj6 \
 		tst-initorder2a tst-initorder2b tst-initorder2c \
 		tst-initorder2d \
 		tst-relsort1mod1 tst-relsort1mod2 tst-array2dep \
-		tst-array5dep tst-null-argv-lib
+		tst-array5dep tst-null-argv-lib \
+		tst-tlsalign-lib
 ifeq (yes,$(have-protected-data))
 modules-names += tst-protected1moda tst-protected1modb
 tests += tst-protected1a tst-protected1b
@@ -525,6 +526,11 @@ $(objpfx)tst-initordera3.so: $(objpfx)tst-initorderb2.so $(objpfx)tst-initorderb
 $(objpfx)tst-initordera4.so: $(objpfx)tst-initordera3.so
 $(objpfx)tst-initorder: $(objpfx)tst-initordera4.so $(objpfx)tst-initordera1.so $(objpfx)tst-initorderb2.so
 $(objpfx)tst-null-argv: $(objpfx)tst-null-argv-lib.so
+$(objpfx)tst-tlsalign: $(objpfx)tst-tlsalign-lib.so
+
+# BZ#18383: broken on at least ARM (both) and x86-64 (static only).
+test-xfail-tst-tlsalign = yes
+test-xfail-tst-tlsalign-static = yes
 
 tst-null-argv-ENV = LD_DEBUG=all LD_DEBUG_OUTPUT=$(objpfx)tst-null-argv.debug.out
 LDFLAGS-nodel2mod3.so = $(no-as-needed)
diff --git a/elf/tst-tlsalign-lib.c b/elf/tst-tlsalign-lib.c
new file mode 100644
index 0000000..4371e58
--- /dev/null
+++ b/elf/tst-tlsalign-lib.c
@@ -0,0 +1,6 @@
+__thread int mod_tdata1 = 1;
+__thread int mod_tdata2 __attribute__ ((aligned (0x10))) = 2;
+__thread int mod_tdata3 __attribute__ ((aligned (0x1000))) = 4;
+__thread int mod_tbss1;
+__thread int mod_tbss2 __attribute__ ((aligned (0x10)));
+__thread int mod_tbss3 __attribute__ ((aligned (0x1000)));
diff --git a/elf/tst-tlsalign-static.c b/elf/tst-tlsalign-static.c
new file mode 100644
index 0000000..1671abf
--- /dev/null
+++ b/elf/tst-tlsalign-static.c
@@ -0,0 +1,2 @@
+#define NO_LIB
+#include "tst-tlsalign.c"
diff --git a/elf/tst-tlsalign.c b/elf/tst-tlsalign.c
new file mode 100644
index 0000000..da04f57
--- /dev/null
+++ b/elf/tst-tlsalign.c
@@ -0,0 +1,85 @@
+/* Test for large alignment in TLS blocks, BZ#18383.
+   Copyright (C) 2015 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <stdint.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+static __thread int tdata1 = 1;
+static __thread int tdata2 __attribute__ ((aligned (0x10))) = 2;
+static __thread int tdata3 __attribute__ ((aligned (0x1000))) = 4;
+static __thread int tbss1;
+static __thread int tbss2 __attribute__ ((aligned (0x10)));
+static __thread int tbss3 __attribute__ ((aligned (0x1000)));
+
+#ifndef NO_LIB
+extern __thread int mod_tdata1;
+extern __thread int mod_tdata2;
+extern __thread int mod_tdata3;
+extern __thread int mod_tbss1;
+extern __thread int mod_tbss2;
+extern __thread int mod_tbss3;
+#endif
+
+static int
+test_one (const char *which, unsigned int alignment, int *var, int value)
+{
+  uintptr_t addr = (uintptr_t) var;
+  unsigned int misalign = addr & (alignment - 1);
+
+  printf ("%s TLS address %p %% %u = %u\n",
+          which, (void *) var, alignment, misalign);
+
+  int got = *var;
+  if (got != value)
+    {
+      printf ("%s value %d should be %d\n", which, got, value);
+      return 1;
+    }
+
+  return misalign != 0;
+}
+
+static int
+do_test (void)
+{
+  int fail = 0;
+
+  fail |= test_one ("tdata1", 4, &tdata1, 1);
+  fail |= test_one ("tdata2", 0x10, &tdata2, 2);
+  fail |= test_one ("tdata3", 0x1000, &tdata3, 4);
+
+  fail |= test_one ("tbss1", 4, &tbss1, 0);
+  fail |= test_one ("tbss2", 0x10, &tbss2, 0);
+  fail |= test_one ("tbss3", 0x1000, &tbss3, 0);
+
+#ifndef NO_LIB
+  fail |= test_one ("mod_tdata1", 4, &mod_tdata1, 1);
+  fail |= test_one ("mod_tdata2", 0x10, &mod_tdata2, 2);
+  fail |= test_one ("mod_tdata3", 0x1000, &mod_tdata3, 4);
+
+  fail |= test_one ("mod_tbss1", 4, &mod_tbss1, 0);
+  fail |= test_one ("mod_tbss2", 0x10, &mod_tbss2, 0);
+  fail |= test_one ("mod_tbss3", 0x1000, &mod_tbss3, 0);
+#endif
+
+  return fail ? EXIT_FAILURE : EXIT_SUCCESS;
+}
+
+#define TEST_FUNCTION do_test ()
+#include "../test-skeleton.c"